<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.device.dao.ibatis.DeviceAlarmInfoDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="DeviceAlarmInfoEntity" id="DeviceAlarmInfoEntity-Map">
        <id  property="id" column="id" />
        <result property="alarmTime" column="alarmTime" />
        <result property="alarmDevice" column="alarmDevice" />
        <result property="alarmType" column="alarmType" />
        <result property="alarmLevel" column="alarmLevel" />
        <result property="alarmReceivePersonnel" column="alarmReceivePersonnel" />
        <result property="receivePersonnelTelephone" column="receivePersonnelTelephone" />
        <result property="alarmStatus" column="alarmStatus" />
        <result property="alarmContent" column="alarmContent" />
        <result property="createTime" column="createTime" />
        <result property="updateUserId" column="updateUserId" />
        <result property="updateTime" column="updateTime" />
        <result property="siteId" column="siteId" />
        <result property="deviceCode" column="deviceCode" />
        <result property="deviceName" column="deviceName" />
        <result property="push" column="push" />
        <result property="productId" column="productId" />
        <result property="productCode" column="productCode" />
        <result property="productName" column="productName" />

    </resultMap>


    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                a.id,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('alarmTime') or colPickMode == 1 and data.containsKey('alarmTime')))">
                a.alarmTime,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('alarmDevice') or colPickMode == 1 and data.containsKey('alarmDevice')))">
                a.alarmDevice,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('alarmType') or colPickMode == 1 and data.containsKey('alarmType')))">
                a.alarmType,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('alarmLevel') or colPickMode == 1 and data.containsKey('alarmLevel')))">
                a.alarmLevel,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('alarmReceivePersonnel') or colPickMode == 1 and data.containsKey('alarmReceivePersonnel')))">
                a.alarmReceivePersonnel,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('receivePersonnelTelephone') or colPickMode == 1 and data.containsKey('receivePersonnelTelephone')))">
                a.receivePersonnelTelephone,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('alarmStatus') or colPickMode == 1 and data.containsKey('alarmStatus')))">
                a.alarmStatus,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('alarmContent') or colPickMode == 1 and data.containsKey('alarmContent')))">
                a.alarmContent,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                a.createTime,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateUserId') or colPickMode == 1 and data.containsKey('updateUserId')))">
                a.updateUserId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                a.updateTime,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('siteId') or colPickMode == 1 and data.containsKey('siteId')))">
                a.siteId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('deviceCode') or colPickMode == 1 and data.containsKey('deviceCode')))">
                a.deviceCode,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('deviceName') or colPickMode == 1 and data.containsKey('deviceName')))">
                a.deviceName,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('push') or colPickMode == 1 and data.containsKey('push')))">
                a.push,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('productId') or colPickMode == 1 and data.containsKey('productId')))">
                a.productId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('productCode') or colPickMode == 1 and data.containsKey('productCode')))">
                a.productCode,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('productName') or colPickMode == 1 and data.containsKey('productName')))">
                a.productName,
            </if>
        </trim>
    </sql>
    <!-- 新增 区分主键自增加还是业务插入 -->
    <insert id="insert" parameterType="DeviceAlarmInfoEntity"  useGeneratedKeys="true" keyProperty="id">
        insert into mortals_xhx_device_alarm_info
        (alarmTime,alarmDevice,alarmType,alarmLevel,alarmReceivePersonnel,receivePersonnelTelephone,alarmStatus,alarmContent,createTime,updateUserId,updateTime,siteId,deviceCode,deviceName,push,productId,productCode,productName)
        VALUES
        (#{alarmTime},#{alarmDevice},#{alarmType},#{alarmLevel},#{alarmReceivePersonnel},#{receivePersonnelTelephone},#{alarmStatus},#{alarmContent},#{createTime},#{updateUserId},#{updateTime},#{siteId},#{deviceCode},#{deviceName},#{push},#{productId},#{productCode},#{productName})
    </insert>

    <!-- 批量新增 -->
    <insert id="insertBatch" parameterType="paramDto">
        insert into mortals_xhx_device_alarm_info
        (alarmTime,alarmDevice,alarmType,alarmLevel,alarmReceivePersonnel,receivePersonnelTelephone,alarmStatus,alarmContent,createTime,updateUserId,updateTime,siteId,deviceCode,deviceName,push,productId,productCode,productName)
        VALUES
        <foreach collection="data.dataList" item="item" index="index" separator="," >
            (#{item.alarmTime},#{item.alarmDevice},#{item.alarmType},#{item.alarmLevel},#{item.alarmReceivePersonnel},#{item.receivePersonnelTelephone},#{item.alarmStatus},#{item.alarmContent},#{item.createTime},#{item.updateUserId},#{item.updateTime},#{item.siteId},#{item.deviceCode},#{item.deviceName},#{item.push},#{item.productId},#{item.productCode},#{item.productName})
        </foreach>
    </insert>


    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_xhx_device_alarm_info as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('alarmTime')) or (colPickMode==1 and !data.containsKey('alarmTime'))">
                a.alarmTime=#{data.alarmTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmDevice')) or (colPickMode==1 and !data.containsKey('alarmDevice'))">
                a.alarmDevice=#{data.alarmDevice},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmDeviceIncrement')) or (colPickMode==1 and !data.containsKey('alarmDeviceIncrement'))">
                a.alarmDevice=ifnull(a.alarmDevice,0) + #{data.alarmDeviceIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmType')) or (colPickMode==1 and !data.containsKey('alarmType'))">
                a.alarmType=#{data.alarmType},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmTypeIncrement')) or (colPickMode==1 and !data.containsKey('alarmTypeIncrement'))">
                a.alarmType=ifnull(a.alarmType,0) + #{data.alarmTypeIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmLevel')) or (colPickMode==1 and !data.containsKey('alarmLevel'))">
                a.alarmLevel=#{data.alarmLevel},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmLevelIncrement')) or (colPickMode==1 and !data.containsKey('alarmLevelIncrement'))">
                a.alarmLevel=ifnull(a.alarmLevel,0) + #{data.alarmLevelIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmReceivePersonnel')) or (colPickMode==1 and !data.containsKey('alarmReceivePersonnel'))">
                a.alarmReceivePersonnel=#{data.alarmReceivePersonnel},
            </if>
            <if test="(colPickMode==0 and data.containsKey('receivePersonnelTelephone')) or (colPickMode==1 and !data.containsKey('receivePersonnelTelephone'))">
                a.receivePersonnelTelephone=#{data.receivePersonnelTelephone},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmStatus')) or (colPickMode==1 and !data.containsKey('alarmStatus'))">
                a.alarmStatus=#{data.alarmStatus},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmStatusIncrement')) or (colPickMode==1 and !data.containsKey('alarmStatusIncrement'))">
                a.alarmStatus=ifnull(a.alarmStatus,0) + #{data.alarmStatusIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmContent')) or (colPickMode==1 and !data.containsKey('alarmContent'))">
                a.alarmContent=#{data.alarmContent},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.createTime=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserId')) or (colPickMode==1 and !data.containsKey('updateUserId'))">
                a.updateUserId=#{data.updateUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !data.containsKey('updateUserIdIncrement'))">
                a.updateUserId=ifnull(a.updateUserId,0) + #{data.updateUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.updateTime=#{data.updateTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('siteId')) or (colPickMode==1 and !data.containsKey('siteId'))">
                a.siteId=#{data.siteId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('siteIdIncrement')) or (colPickMode==1 and !data.containsKey('siteIdIncrement'))">
                a.siteId=ifnull(a.siteId,0) + #{data.siteIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('deviceCode')) or (colPickMode==1 and !data.containsKey('deviceCode'))">
                a.deviceCode=#{data.deviceCode},
            </if>
            <if test="(colPickMode==0 and data.containsKey('deviceName')) or (colPickMode==1 and !data.containsKey('deviceName'))">
                a.deviceName=#{data.deviceName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('push')) or (colPickMode==1 and !data.containsKey('push'))">
                a.push=#{data.push},
            </if>
            <if test="(colPickMode==0 and data.containsKey('pushIncrement')) or (colPickMode==1 and !data.containsKey('pushIncrement'))">
                a.push=ifnull(a.push,0) + #{data.pushIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('productId')) or (colPickMode==1 and !data.containsKey('productId'))">
                a.productId=#{data.productId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('productIdIncrement')) or (colPickMode==1 and !data.containsKey('productIdIncrement'))">
                a.productId=ifnull(a.productId,0) + #{data.productIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('productCode')) or (colPickMode==1 and !data.containsKey('productCode'))">
                a.productCode=#{data.productCode},
            </if>
            <if test="(colPickMode==0 and data.containsKey('productName')) or (colPickMode==1 and !data.containsKey('productName'))">
                a.productName=#{data.productName},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_xhx_device_alarm_info as a
        <trim prefix="set" suffixOverrides=",">
            <trim prefix="alarmTime=(case" suffix="ELSE alarmTime end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('alarmTime')) or (colPickMode==1 and !item.containsKey('alarmTime'))">
                        when a.id=#{item.id} then #{item.alarmTime}
                    </if>
                </foreach>
            </trim>
            <trim prefix="alarmDevice=(case" suffix="ELSE alarmDevice end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('alarmDevice')) or (colPickMode==1 and !item.containsKey('alarmDevice'))">
                            when a.id=#{item.id} then #{item.alarmDevice}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('alarmDeviceIncrement')) or (colPickMode==1 and !item.containsKey('alarmDeviceIncrement'))">
                            when a.id=#{item.id} then ifnull(a.alarmDevice,0) + #{item.alarmDeviceIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="alarmType=(case" suffix="ELSE alarmType end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('alarmType')) or (colPickMode==1 and !item.containsKey('alarmType'))">
                            when a.id=#{item.id} then #{item.alarmType}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('alarmTypeIncrement')) or (colPickMode==1 and !item.containsKey('alarmTypeIncrement'))">
                            when a.id=#{item.id} then ifnull(a.alarmType,0) + #{item.alarmTypeIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="alarmLevel=(case" suffix="ELSE alarmLevel end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('alarmLevel')) or (colPickMode==1 and !item.containsKey('alarmLevel'))">
                            when a.id=#{item.id} then #{item.alarmLevel}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('alarmLevelIncrement')) or (colPickMode==1 and !item.containsKey('alarmLevelIncrement'))">
                            when a.id=#{item.id} then ifnull(a.alarmLevel,0) + #{item.alarmLevelIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="alarmReceivePersonnel=(case" suffix="ELSE alarmReceivePersonnel end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('alarmReceivePersonnel')) or (colPickMode==1 and !item.containsKey('alarmReceivePersonnel'))">
                        when a.id=#{item.id} then #{item.alarmReceivePersonnel}
                    </if>
                </foreach>
            </trim>
            <trim prefix="receivePersonnelTelephone=(case" suffix="ELSE receivePersonnelTelephone end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('receivePersonnelTelephone')) or (colPickMode==1 and !item.containsKey('receivePersonnelTelephone'))">
                        when a.id=#{item.id} then #{item.receivePersonnelTelephone}
                    </if>
                </foreach>
            </trim>
            <trim prefix="alarmStatus=(case" suffix="ELSE alarmStatus end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('alarmStatus')) or (colPickMode==1 and !item.containsKey('alarmStatus'))">
                            when a.id=#{item.id} then #{item.alarmStatus}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('alarmStatusIncrement')) or (colPickMode==1 and !item.containsKey('alarmStatusIncrement'))">
                            when a.id=#{item.id} then ifnull(a.alarmStatus,0) + #{item.alarmStatusIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="alarmContent=(case" suffix="ELSE alarmContent end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('alarmContent')) or (colPickMode==1 and !item.containsKey('alarmContent'))">
                        when a.id=#{item.id} then #{item.alarmContent}
                    </if>
                </foreach>
            </trim>
            <trim prefix="createTime=(case" suffix="ELSE createTime end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                        when a.id=#{item.id} then #{item.createTime}
                    </if>
                </foreach>
            </trim>
            <trim prefix="updateUserId=(case" suffix="ELSE updateUserId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('updateUserId')) or (colPickMode==1 and !item.containsKey('updateUserId'))">
                            when a.id=#{item.id} then #{item.updateUserId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !item.containsKey('updateUserIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.updateUserId,0) + #{item.updateUserIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="updateTime=(case" suffix="ELSE updateTime end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                        when a.id=#{item.id} then #{item.updateTime}
                    </if>
                </foreach>
            </trim>
            <trim prefix="siteId=(case" suffix="ELSE siteId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('siteId')) or (colPickMode==1 and !item.containsKey('siteId'))">
                            when a.id=#{item.id} then #{item.siteId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('siteIdIncrement')) or (colPickMode==1 and !item.containsKey('siteIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.siteId,0) + #{item.siteIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="deviceCode=(case" suffix="ELSE deviceCode end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('deviceCode')) or (colPickMode==1 and !item.containsKey('deviceCode'))">
                        when a.id=#{item.id} then #{item.deviceCode}
                    </if>
                </foreach>
            </trim>
            <trim prefix="deviceName=(case" suffix="ELSE deviceName end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('deviceName')) or (colPickMode==1 and !item.containsKey('deviceName'))">
                        when a.id=#{item.id} then #{item.deviceName}
                    </if>
                </foreach>
            </trim>
            <trim prefix="push=(case" suffix="ELSE push end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('push')) or (colPickMode==1 and !item.containsKey('push'))">
                            when a.id=#{item.id} then #{item.push}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('pushIncrement')) or (colPickMode==1 and !item.containsKey('pushIncrement'))">
                            when a.id=#{item.id} then ifnull(a.push,0) + #{item.pushIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="productId=(case" suffix="ELSE productId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('productId')) or (colPickMode==1 and !item.containsKey('productId'))">
                            when a.id=#{item.id} then #{item.productId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('productIdIncrement')) or (colPickMode==1 and !item.containsKey('productIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.productId,0) + #{item.productIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="productCode=(case" suffix="ELSE productCode end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('productCode')) or (colPickMode==1 and !item.containsKey('productCode'))">
                        when a.id=#{item.id} then #{item.productCode}
                    </if>
                </foreach>
            </trim>
            <trim prefix="productName=(case" suffix="ELSE productName end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('productName')) or (colPickMode==1 and !item.containsKey('productName'))">
                        when a.id=#{item.id} then #{item.productName}
                    </if>
                </foreach>
            </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="DeviceAlarmInfoEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_device_alarm_info as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_xhx_device_alarm_info as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_xhx_device_alarm_info where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据主健列表删除一批，针对单一主健有效 -->
    <delete id="deleteByKeyList">
        delete from mortals_xhx_device_alarm_info where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>

    <!-- 根据对象列表删除一批，针对单一主健有效 -->
    <delete id="deleteByEntityList">
        delete from mortals_xhx_device_alarm_info where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_xhx_device_alarm_info as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="DeviceAlarmInfoEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_device_alarm_info as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>



    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_xhx_device_alarm_info as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null ">
                ${_conditionType_} a.id = #{${_conditionParam_}.id}
            </if>
            <if test="conditionParamRef.id == null">
                ${_conditionType_} a.id is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
            ${_conditionType_} a.id in
            <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('idNotList') and conditionParamRef.idNotList.size() > 0">
            ${_conditionType_} a.id not in
            <foreach collection="conditionParamRef.idNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
            ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
        </if>
        <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
            ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
        </if>


        <if test="conditionParamRef.containsKey('alarmTime')">
            <if test="conditionParamRef.alarmTime != null ">
                ${_conditionType_} a.alarmTime = #{${_conditionParam_}.alarmTime}
            </if>
            <if test="conditionParamRef.alarmTime == null">
                ${_conditionType_} a.alarmTime is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('alarmTimeStart') and conditionParamRef.alarmTimeStart != null and conditionParamRef.alarmTimeStart!=''">
            ${_conditionType_} a.alarmTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.alarmTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('alarmTimeEnd') and conditionParamRef.alarmTimeEnd != null and conditionParamRef.alarmTimeEnd!=''">
            ${_conditionType_} a.alarmTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.alarmTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('alarmDevice')">
            <if test="conditionParamRef.alarmDevice != null ">
                ${_conditionType_} a.alarmDevice = #{${_conditionParam_}.alarmDevice}
            </if>
            <if test="conditionParamRef.alarmDevice == null">
                ${_conditionType_} a.alarmDevice is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('alarmDeviceList') and conditionParamRef.alarmDeviceList.size() > 0">
            ${_conditionType_} a.alarmDevice in
            <foreach collection="conditionParamRef.alarmDeviceList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmDeviceNotList') and conditionParamRef.alarmDeviceNotList.size() > 0">
            ${_conditionType_} a.alarmDevice not in
            <foreach collection="conditionParamRef.alarmDeviceNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmDeviceStart') and conditionParamRef.alarmDeviceStart != null">
            ${_conditionType_} a.alarmDevice <![CDATA[ >= ]]> #{${_conditionParam_}.alarmDeviceStart}
        </if>
        <if test="conditionParamRef.containsKey('alarmDeviceEnd') and conditionParamRef.alarmDeviceEnd != null">
            ${_conditionType_} a.alarmDevice <![CDATA[ <= ]]> #{${_conditionParam_}.alarmDeviceEnd}
        </if>

        <if test="conditionParamRef.containsKey('alarmType')">
            <if test="conditionParamRef.alarmType != null ">
                ${_conditionType_} a.alarmType = #{${_conditionParam_}.alarmType}
            </if>
            <if test="conditionParamRef.alarmType == null">
                ${_conditionType_} a.alarmType is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('alarmTypeList') and conditionParamRef.alarmTypeList.size() > 0">
            ${_conditionType_} a.alarmType in
            <foreach collection="conditionParamRef.alarmTypeList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmTypeNotList') and conditionParamRef.alarmTypeNotList.size() > 0">
            ${_conditionType_} a.alarmType not in
            <foreach collection="conditionParamRef.alarmTypeNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmTypeStart') and conditionParamRef.alarmTypeStart != null">
            ${_conditionType_} a.alarmType <![CDATA[ >= ]]> #{${_conditionParam_}.alarmTypeStart}
        </if>
        <if test="conditionParamRef.containsKey('alarmTypeEnd') and conditionParamRef.alarmTypeEnd != null">
            ${_conditionType_} a.alarmType <![CDATA[ <= ]]> #{${_conditionParam_}.alarmTypeEnd}
        </if>

        <if test="conditionParamRef.containsKey('alarmLevel')">
            <if test="conditionParamRef.alarmLevel != null ">
                ${_conditionType_} a.alarmLevel = #{${_conditionParam_}.alarmLevel}
            </if>
            <if test="conditionParamRef.alarmLevel == null">
                ${_conditionType_} a.alarmLevel is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('alarmLevelList') and conditionParamRef.alarmLevelList.size() > 0">
            ${_conditionType_} a.alarmLevel in
            <foreach collection="conditionParamRef.alarmLevelList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmLevelNotList') and conditionParamRef.alarmLevelNotList.size() > 0">
            ${_conditionType_} a.alarmLevel not in
            <foreach collection="conditionParamRef.alarmLevelNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmLevelStart') and conditionParamRef.alarmLevelStart != null">
            ${_conditionType_} a.alarmLevel <![CDATA[ >= ]]> #{${_conditionParam_}.alarmLevelStart}
        </if>
        <if test="conditionParamRef.containsKey('alarmLevelEnd') and conditionParamRef.alarmLevelEnd != null">
            ${_conditionType_} a.alarmLevel <![CDATA[ <= ]]> #{${_conditionParam_}.alarmLevelEnd}
        </if>


        <if test="conditionParamRef.containsKey('alarmReceivePersonnel')">
            <if test="conditionParamRef.alarmReceivePersonnel != null and conditionParamRef.alarmReceivePersonnel != ''">
                ${_conditionType_} a.alarmReceivePersonnel like #{${_conditionParam_}.alarmReceivePersonnel}
            </if>
            <if test="conditionParamRef.alarmReceivePersonnel == null">
                ${_conditionType_} a.alarmReceivePersonnel is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('alarmReceivePersonnelList') and conditionParamRef.alarmReceivePersonnelList.size() > 0">
            ${_conditionType_} a.alarmReceivePersonnel in
            <foreach collection="conditionParamRef.alarmReceivePersonnelList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmReceivePersonnelNotList') and conditionParamRef.alarmReceivePersonnelNotList.size() > 0">
            ${_conditionType_} a.alarmReceivePersonnel not in
            <foreach collection="conditionParamRef.alarmReceivePersonnelNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('receivePersonnelTelephone')">
            <if test="conditionParamRef.receivePersonnelTelephone != null and conditionParamRef.receivePersonnelTelephone != ''">
                ${_conditionType_} a.receivePersonnelTelephone like #{${_conditionParam_}.receivePersonnelTelephone}
            </if>
            <if test="conditionParamRef.receivePersonnelTelephone == null">
                ${_conditionType_} a.receivePersonnelTelephone is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('receivePersonnelTelephoneList') and conditionParamRef.receivePersonnelTelephoneList.size() > 0">
            ${_conditionType_} a.receivePersonnelTelephone in
            <foreach collection="conditionParamRef.receivePersonnelTelephoneList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('receivePersonnelTelephoneNotList') and conditionParamRef.receivePersonnelTelephoneNotList.size() > 0">
            ${_conditionType_} a.receivePersonnelTelephone not in
            <foreach collection="conditionParamRef.receivePersonnelTelephoneNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmStatus')">
            <if test="conditionParamRef.alarmStatus != null ">
                ${_conditionType_} a.alarmStatus = #{${_conditionParam_}.alarmStatus}
            </if>
            <if test="conditionParamRef.alarmStatus == null">
                ${_conditionType_} a.alarmStatus is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('alarmStatusList') and conditionParamRef.alarmStatusList.size() > 0">
            ${_conditionType_} a.alarmStatus in
            <foreach collection="conditionParamRef.alarmStatusList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmStatusNotList') and conditionParamRef.alarmStatusNotList.size() > 0">
            ${_conditionType_} a.alarmStatus not in
            <foreach collection="conditionParamRef.alarmStatusNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmStatusStart') and conditionParamRef.alarmStatusStart != null">
            ${_conditionType_} a.alarmStatus <![CDATA[ >= ]]> #{${_conditionParam_}.alarmStatusStart}
        </if>
        <if test="conditionParamRef.containsKey('alarmStatusEnd') and conditionParamRef.alarmStatusEnd != null">
            ${_conditionType_} a.alarmStatus <![CDATA[ <= ]]> #{${_conditionParam_}.alarmStatusEnd}
        </if>


        <if test="conditionParamRef.containsKey('alarmContent')">
            <if test="conditionParamRef.alarmContent != null and conditionParamRef.alarmContent != ''">
                ${_conditionType_} a.alarmContent like #{${_conditionParam_}.alarmContent}
            </if>
            <if test="conditionParamRef.alarmContent == null">
                ${_conditionType_} a.alarmContent is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('alarmContentList') and conditionParamRef.alarmContentList.size() > 0">
            ${_conditionType_} a.alarmContent in
            <foreach collection="conditionParamRef.alarmContentList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('alarmContentNotList') and conditionParamRef.alarmContentNotList.size() > 0">
            ${_conditionType_} a.alarmContent not in
            <foreach collection="conditionParamRef.alarmContentNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('createTime')">
            <if test="conditionParamRef.createTime != null ">
                ${_conditionType_} a.createTime = #{${_conditionParam_}.createTime}
            </if>
            <if test="conditionParamRef.createTime == null">
                ${_conditionType_} a.createTime is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
            ${_conditionType_} a.createTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
            ${_conditionType_} a.createTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('updateUserId')">
            <if test="conditionParamRef.updateUserId != null ">
                ${_conditionType_} a.updateUserId = #{${_conditionParam_}.updateUserId}
            </if>
            <if test="conditionParamRef.updateUserId == null">
                ${_conditionType_} a.updateUserId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdList') and conditionParamRef.updateUserIdList.size() > 0">
            ${_conditionType_} a.updateUserId in
            <foreach collection="conditionParamRef.updateUserIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdNotList') and conditionParamRef.updateUserIdNotList.size() > 0">
            ${_conditionType_} a.updateUserId not in
            <foreach collection="conditionParamRef.updateUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdStart') and conditionParamRef.updateUserIdStart != null">
            ${_conditionType_} a.updateUserId <![CDATA[ >= ]]> #{${_conditionParam_}.updateUserIdStart}
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdEnd') and conditionParamRef.updateUserIdEnd != null">
            ${_conditionType_} a.updateUserId <![CDATA[ <= ]]> #{${_conditionParam_}.updateUserIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('updateTime')">
            <if test="conditionParamRef.updateTime != null ">
                ${_conditionType_} a.updateTime = #{${_conditionParam_}.updateTime}
            </if>
            <if test="conditionParamRef.updateTime == null">
                ${_conditionType_} a.updateTime is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
            ${_conditionType_} a.updateTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
            ${_conditionType_} a.updateTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('siteId')">
            <if test="conditionParamRef.siteId != null ">
                ${_conditionType_} a.siteId = #{${_conditionParam_}.siteId}
            </if>
            <if test="conditionParamRef.siteId == null">
                ${_conditionType_} a.siteId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('siteIdList') and conditionParamRef.siteIdList.size() > 0">
            ${_conditionType_} a.siteId in
            <foreach collection="conditionParamRef.siteIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('siteIdNotList') and conditionParamRef.siteIdNotList.size() > 0">
            ${_conditionType_} a.siteId not in
            <foreach collection="conditionParamRef.siteIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('siteIdStart') and conditionParamRef.siteIdStart != null">
            ${_conditionType_} a.siteId <![CDATA[ >= ]]> #{${_conditionParam_}.siteIdStart}
        </if>
        <if test="conditionParamRef.containsKey('siteIdEnd') and conditionParamRef.siteIdEnd != null">
            ${_conditionType_} a.siteId <![CDATA[ <= ]]> #{${_conditionParam_}.siteIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('deviceCode')">
            <if test="conditionParamRef.deviceCode != null and conditionParamRef.deviceCode != ''">
                ${_conditionType_} a.deviceCode like #{${_conditionParam_}.deviceCode}
            </if>
            <if test="conditionParamRef.deviceCode == null">
                ${_conditionType_} a.deviceCode is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('deviceCodeList') and conditionParamRef.deviceCodeList.size() > 0">
            ${_conditionType_} a.deviceCode in
            <foreach collection="conditionParamRef.deviceCodeList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('deviceCodeNotList') and conditionParamRef.deviceCodeNotList.size() > 0">
            ${_conditionType_} a.deviceCode not in
            <foreach collection="conditionParamRef.deviceCodeNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('deviceName')">
            <if test="conditionParamRef.deviceName != null and conditionParamRef.deviceName != ''">
                ${_conditionType_} a.deviceName like #{${_conditionParam_}.deviceName}
            </if>
            <if test="conditionParamRef.deviceName == null">
                ${_conditionType_} a.deviceName is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('deviceNameList') and conditionParamRef.deviceNameList.size() > 0">
            ${_conditionType_} a.deviceName in
            <foreach collection="conditionParamRef.deviceNameList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('deviceNameNotList') and conditionParamRef.deviceNameNotList.size() > 0">
            ${_conditionType_} a.deviceName not in
            <foreach collection="conditionParamRef.deviceNameNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('push')">
            <if test="conditionParamRef.push != null ">
                ${_conditionType_} a.push = #{${_conditionParam_}.push}
            </if>
            <if test="conditionParamRef.push == null">
                ${_conditionType_} a.push is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('pushList') and conditionParamRef.pushList.size() > 0">
            ${_conditionType_} a.push in
            <foreach collection="conditionParamRef.pushList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('pushNotList') and conditionParamRef.pushNotList.size() > 0">
            ${_conditionType_} a.push not in
            <foreach collection="conditionParamRef.pushNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('pushStart') and conditionParamRef.pushStart != null">
            ${_conditionType_} a.push <![CDATA[ >= ]]> #{${_conditionParam_}.pushStart}
        </if>
        <if test="conditionParamRef.containsKey('pushEnd') and conditionParamRef.pushEnd != null">
            ${_conditionType_} a.push <![CDATA[ <= ]]> #{${_conditionParam_}.pushEnd}
        </if>

        <if test="conditionParamRef.containsKey('productId')">
            <if test="conditionParamRef.productId != null ">
                ${_conditionType_} a.productId = #{${_conditionParam_}.productId}
            </if>
            <if test="conditionParamRef.productId == null">
                ${_conditionType_} a.productId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('productIdList') and conditionParamRef.productIdList.size() > 0">
            ${_conditionType_} a.productId in
            <foreach collection="conditionParamRef.productIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('productIdNotList') and conditionParamRef.productIdNotList.size() > 0">
            ${_conditionType_} a.productId not in
            <foreach collection="conditionParamRef.productIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('productIdStart') and conditionParamRef.productIdStart != null">
            ${_conditionType_} a.productId <![CDATA[ >= ]]> #{${_conditionParam_}.productIdStart}
        </if>
        <if test="conditionParamRef.containsKey('productIdEnd') and conditionParamRef.productIdEnd != null">
            ${_conditionType_} a.productId <![CDATA[ <= ]]> #{${_conditionParam_}.productIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('productCode')">
            <if test="conditionParamRef.productCode != null and conditionParamRef.productCode != ''">
                ${_conditionType_} a.productCode like #{${_conditionParam_}.productCode}
            </if>
            <if test="conditionParamRef.productCode == null">
                ${_conditionType_} a.productCode is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('productCodeList') and conditionParamRef.productCodeList.size() > 0">
            ${_conditionType_} a.productCode in
            <foreach collection="conditionParamRef.productCodeList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('productCodeNotList') and conditionParamRef.productCodeNotList.size() > 0">
            ${_conditionType_} a.productCode not in
            <foreach collection="conditionParamRef.productCodeNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('productName')">
            <if test="conditionParamRef.productName != null and conditionParamRef.productName != ''">
                ${_conditionType_} a.productName like #{${_conditionParam_}.productName}
            </if>
            <if test="conditionParamRef.productName == null">
                ${_conditionType_} a.productName is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('productNameList') and conditionParamRef.productNameList.size() > 0">
            ${_conditionType_} a.productName in
            <foreach collection="conditionParamRef.productNameList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('productNameNotList') and conditionParamRef.productNameNotList.size() > 0">
            ${_conditionType_} a.productName not in
            <foreach collection="conditionParamRef.productNameNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                    ${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <if test="orderCol.containsKey('id')">
                    a.id
                    <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('alarmTime')">
                    a.alarmTime
                    <if test='orderCol.alarmTime != null and "DESC".equalsIgnoreCase(orderCol.alarmTime)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('alarmDevice')">
                    a.alarmDevice
                    <if test='orderCol.alarmDevice != null and "DESC".equalsIgnoreCase(orderCol.alarmDevice)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('alarmType')">
                    a.alarmType
                    <if test='orderCol.alarmType != null and "DESC".equalsIgnoreCase(orderCol.alarmType)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('alarmLevel')">
                    a.alarmLevel
                    <if test='orderCol.alarmLevel != null and "DESC".equalsIgnoreCase(orderCol.alarmLevel)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('alarmReceivePersonnel')">
                    a.alarmReceivePersonnel
                    <if test='orderCol.alarmReceivePersonnel != null and "DESC".equalsIgnoreCase(orderCol.alarmReceivePersonnel)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('receivePersonnelTelephone')">
                    a.receivePersonnelTelephone
                    <if test='orderCol.receivePersonnelTelephone != null and "DESC".equalsIgnoreCase(orderCol.receivePersonnelTelephone)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('alarmStatus')">
                    a.alarmStatus
                    <if test='orderCol.alarmStatus != null and "DESC".equalsIgnoreCase(orderCol.alarmStatus)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('alarmContent')">
                    a.alarmContent
                    <if test='orderCol.alarmContent != null and "DESC".equalsIgnoreCase(orderCol.alarmContent)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('createTime')">
                    a.createTime
                    <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('updateUserId')">
                    a.updateUserId
                    <if test='orderCol.updateUserId != null and "DESC".equalsIgnoreCase(orderCol.updateUserId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('updateTime')">
                    a.updateTime
                    <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('siteId')">
                    a.siteId
                    <if test='orderCol.siteId != null and "DESC".equalsIgnoreCase(orderCol.siteId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('deviceCode')">
                    a.deviceCode
                    <if test='orderCol.deviceCode != null and "DESC".equalsIgnoreCase(orderCol.deviceCode)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('deviceName')">
                    a.deviceName
                    <if test='orderCol.deviceName != null and "DESC".equalsIgnoreCase(orderCol.deviceName)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('push')">
                    a.push
                    <if test='orderCol.push != null and "DESC".equalsIgnoreCase(orderCol.push)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('productId')">
                    a.productId
                    <if test='orderCol.productId != null and "DESC".equalsIgnoreCase(orderCol.productId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('productCode')">
                    a.productCode
                    <if test='orderCol.productCode != null and "DESC".equalsIgnoreCase(orderCol.productCode)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('productName')">
                    a.productName
                    <if test='orderCol.productName != null and "DESC".equalsIgnoreCase(orderCol.productName)'>DESC</if>
                    ,
                </if>
            </trim>
        </if>
    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>